/*	
 *	clipmisc.h
 *
 *	G[Ȃ낢łB
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jan 26 19:33:00 JST 2003 Naoyuki Sawa
 *	- die()֐__attribute__((noreturn))ǉB
 *	  :__attribute__((...))͊֐錾̂ݎw\łB
 *	       ֐Ɏw肷ƃRpCG[ƂȂ܂B
 *	* Sun May 4 18:05:00 JST 2003 Naoyuki Sawa
 *	- fpk_size()/fpk_load()ǉ܂B
 *	* Wed Aug 20 06:00:00 JST 2003 Naoyuki Sawa
 *	- fpk_address()ǉ܂B
 *	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
 *	- g[Xo(TRACE_ON/TRACE/trace())ǉ܂B
 *	* Sun Dec 28 13:49:00 JST 2003 Naoyuki Sawa
 *	- DDA\̂cliprend.hړĂ܂B
 *	* Thu Jul 22 12:30:00 JST 2004 Naoyuki Sawa
 *	- RND8_RANGE()RND16_RANGE()ǉ܂B
 *	- COUNTOF()ǉ܂B
 */
#ifndef __CLIP_MISC_H__
#define __CLIP_MISC_H__

/*****************************************************************************
 *	ėp}N
 *****************************************************************************/

#define DIE()		die(__FILE__ "(%d)", __LINE__)
#ifdef DEBUG
#define ASSERT(f)	((void)((f) || (die(__FILE__ "(%d): %s", __LINE__, #f), 0)))
#define VERIFY(f)	ASSERT(f)
#else /*DEBUG*/
#define ASSERT(f)	((void)0)
#define VERIFY(f)	((void)(f))
#endif /*DEBUG*/

/* rbg */
#define BTST(a, b)	(((char*)(a))[(b) / 8] &    1 << ((b) & 7) )
#define BCLR(a, b)	(((char*)(a))[(b) / 8] &= ~(1 << ((b) & 7)))
#define BSET(a, b)	(((char*)(a))[(b) / 8] |=   1 << ((b) & 7) )
#define BNOT(a, b)	(((char*)(a))[(b) / 8] ^=   1 << ((b) & 7) )

/* 16rbgl̃oCgXbv */
#define SWAPH(a) \
	(((a) >> 8 & 0x00ff) | \
	 ((a) << 8 & 0xff00))
/* 32rbgl̃oCgXbv */
#define SWAPW(a) \
	(((a) >> 24 & 0x000000ff) | \
	 ((a) >>  8 & 0x0000ff00) | \
	 ((a) <<  8 & 0x00ff0000) | \
	 ((a) << 24 & 0xff000000))

/* 8rbg(wZ80}V`̏x) */
#define RND8(s)		(((s) = (s) * 5 + 0x3711) >> 8 & 0xff)
/* 16rbg(VisualC++ 6.0 \VC98\CRT\SRC\RAND.C Qlɂ܂) */
#define RND16(s)	(((s) = (s) * 214013 + 2531011) >> 16 & 0xffff)

/* (a)ȏ(b)̗𐶐 */
#define RND8_RANGE(s, a, b)	(RND8(s) % ((b) - (a)) + (a))
#define RND16_RANGE(s, a, b)	(RND16(s) % ((b) - (a)) + (a))

/* z̗vf擾}N */
#define COUNTOF(a)	(sizeof (a) / sizeof *(a))

/* DDA(Digital Differential Analysis)\ */
typedef struct _DDA {
	int n;			/* + 0,4 [̑     */
	int d;			/* + 4,4 [             */
	int u;			/* + 8,4 ̕ω     */
	int v;			/* +12,4 Jグ̕ω */
				/* =16                    */
} DDA;

/*****************************************************************************
 *	G[
 *****************************************************************************/

/* G[bZ[W\AvOI܂B
 * [in]
 *	fmt,...		printf()̈ƓlłB
 * [note]
 *	* ̊֐͏Ԃ܂B
 */
void die(const char* fmt, ...) __attribute__((noreturn));

/*****************************************************************************
 *	g[Xo
 *****************************************************************************/

/* !!v!! TRACE()}N̓AvP[VpłBCLiPCu̒ŎgȂ悤!!
 *            (TRACE()}NTRACE_ONV{̒`ɂĐU镑ς̂ŁA
 *             炩߃RpC郉Cu̒łTRACE_ONɂU镑̐؂ւȂ)
 *
 * * g[Xo͂𗘗pꍇ́A  clip.hCN[hOɁu#define TRACE_ON 1v`ĂB
 *   g[Xo͂𗘗pȂꍇ́Aclip.hCN[hOɁu#define TRACE_ON 0v`邩A
 *   ܂TRACE_ONV{`ȂłB
 * * g[Xo͂𗘗pȂꍇ́Ag[XCRpC̍œKɂč폜܂B
 *   TRACE()Ăяo폜ȂĂAg[X񂪃邱Ƃ͂܂B
 */
#if defined(TRACE_ON) && (TRACE_ON)
#define TRACE	trace
#else
#define TRACE	1 ? (void)0 : trace
#endif

/* WG[o͂ւfprintfłB
 * [in]
 *	fmt,...		printf()̈ƓlłB
 * [note]
 *	* TRACE}NoRŗp܂B
 */
void trace(const char* fmt, ...);

/*****************************************************************************
 *	[eBeBFt@CpbN`
 *****************************************************************************/

/*                           0 +-----------------------------+
 *                             | FILE_PAC_INFO               |
 *                             +-----------------------------+
 *                             | FILE_INFO[0]                |
 *                             +-----------------------------+
 *                             | FILE_INFO[1]                |
 *                             +-----------------------------+
 *                             =                             =
 *                             +-----------------------------+
 *                             | FILE_INFO[famount-1]        |
 *         FILE_INFO[0].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[0]̃f[^         |bFILE_INFO[0].size + 3 & ~3
 *                             |                             |
 *         FILE_INFO[1].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[1]̃f[^         |bFILE_INFO[1].size + 3 & ~3
 *                             |                             |
 *                             +-----------------------------+|
 *                             =                             =
 * FILE_INFO[famount-1].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[famount-1]̃f[^ |bFILE_INFO[famount-1].size
 *                             |                             |
 *                             +-----------------------------+|
 */
#define FILE_PAC_INFO_HEAD	 ('F' << 24 | 'P' << 16 | 'A' << 8 | 'K')
typedef struct _FILE_PAC_INFO {	/* t@CpbN                   */
	unsigned long head;	/* VOl`('FPAK'ŒBт"KAPF") */
	long famount;		/* t@C                           */
} FILE_PAC_INFO;
typedef struct _FILE_INFO {	/* t@C                         */
	char fname[16];		/* t@C                           */
	unsigned long offset;	/* ItZbg(fpkt@C擪0Ƃ) */
	unsigned long size;	/* t@CTCY                       */
} FILE_INFO;

/* fpkt@C̃t@CTCY擾܂B
 * [in]
 *	fname		fpkt@CB
 *	name		t@CGgB
 * [out]
 *	߂l		t@CTCY[oCg]B
 * [note]
 *	* t@CGǵA啶ʂɔr܂B
 *	* t@CGgȂꍇ́AAT[g܂B
 */
int fpk_size(const char* fname, const char* name);

/* fpkt@C̃t@Cǂݍ݂܂B
 * [in]
 *	fname		fpkt@CB
 *	name		t@CGgB
 *	buffer		obt@AhXB
 *	buflen		obt@TCYB
 * [out]
 *	߂l		ۂɓǂݍ񂾃t@CTCY[oCg]B
 * [note]
 *	* t@CGǵA啶ʂɔr܂B
 *	* t@CGgȂꍇ́AAT[g܂B
 *	* obt@TCYt@CTCY̏ꍇ́AAT[g܂B
 */
int fpk_load(const char* fname, const char* name, void* buffer, int buflen);

/*****************************************************************************
 *	[eBeBFIt@CpbN`
 *****************************************************************************/

/* Ifpk̃t@C擪AhX擾܂B
 * [in]
 *	fpk		Ifpk̐擪AhXB
 *	name		t@CGgB
 *	size		t@CTCYi[ϐւ̃|C^B
 *			NULLw肷ƃt@CTCY͊i[܂B
 * [out]
 *	߂l		ۂɓǂݍ񂾃t@CTCY[oCg]B
 * [note]
 *	* t@CGǵA啶ʂɔr܂B
 *	* t@CGgȂꍇ́AAT[g܂B
 */
const void* fpk_address(const void* fpk, const char* name, int* size);

#endif /*__CLIP_MISC_H__*/
