/*
 *	app.h
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO 7 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
//#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_RI)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

//#define TEXTURE_LIST	PAT0,PAT1,PAT2	/* eNX`Xg */
//#define TEXTURE_COUNT	3		/* eNX`̐ */
#define TEXTURE_LIST	PAT,BG,TITLE	/* eNX`Xg */
#define TEXTURE_COUNT	3		/* eNX`̐ */

/****************************************************************************
 *	
 ****************************************************************************/

#define CELL_W		9		/* ZTCY */
#define CELL_H		9

#define FIELD_X		5		/* tB[h_ */
#define FIELD_Y		(4 - 9)

#define NEXT_X		66		/* NEXTずZ_ */
#define NEXT_Y		3

#define SCORE_X		62		/* SCORE`挴_ */
#define SCORE_Y		46

#define COSMO_X		66		/* COSMO`挴_ */
#define COSMO_Y		64

#define LINES_X		68		/* LINES`挴_ */
#define LINES_Y		82

#define LEVEL_X		68		/* LEVEL`挴_ */
#define LEVEL_Y		100

#define STAR_X		59		/* X^[[^[_ */
#define STAR_Y		108
#define STAR_FILL_X	63		/* X^[[^[hԂ͈ */
#define STAR_FILL_Y	116
#define STAR_FILL_W	23
#define STAR_FILL_H	8

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _CELL {
	short type;	/* + 0,2: Z̎ (CELL_*) */
	short border;	/* + 2,2: Zg\ (0:/1:L) */
	short stat;	/* + 4,2:  (ėp) */
	short _resv;	/* + 6,2: (pfBO) */
	int cnt1;	/* + 8,4: JE^1 (ėp) */
	int cnt2;	/* +12,4: JE^2 (ėp) */
} CELL;			/* =16 */

/* CELL.type */
#define CELL_COSMO	1	/* RY */
#define CELL_CONTAINER	2	/* Rei */
#define CELL_BALL	3	/* {[ */
#define CELL_STAR	4	/* X^[ */

/*** COSMO ***
 *
 * [stat = 0:ʏ]
 *	cnt1	Aj[VJE^B
 *	cnt2	Jn܂ł̎c莞ԁB
 *		Aj[V̋؂Ŏc莞ԂAc莞Ԃ0ȉȂΐJnֈڍsB
 *
 * [stat = 1:Jn]
 *	cnt1	Aj[VJE^B
 *		Aj[VɂĐֈڍsB
 *
 * [stat = 2:]
 *	cnt1	Aj[VJE^B
 *	cnt2	N܂ł̎c莞ԁB
 *		Aj[V̋؂Ŏc莞ԂAc莞Ԃ0ȉȂΎN#1܂#2ֈڍsB
 *		Aj[V̋؂́AAj[V̓rł邱Ƃɒ!!(΂񉺂)
 *		N#1#2̔䗦́A#1̕Ȃ葽߂ɁB(#1:#2=3:1炢?)
 *
 * [stat = 3:N#1]
 *	cnt1	Aj[VJE^B
 *		Aj[VɂĐJnֈڍsB
 *
 * [stat = 4:N#2]
 *	cnt1	Aj[VJE^B
 *		Aj[VɂĐJnֈڍsB
 *
 * [stat = 5:#1]
 *	cnt1	Aj[VJE^B
 *		Aj[VɂĐ#2ֈڍsB
 *
 * [stat = 6:#2]
 *	cnt1	Aj[VJE^B
 *		Aj[VɂĒʏֈڍsB
 *		#2̃Aj[V́AN#1̃Aj[VƓB
 *
 * [stat = 7:Q[I[o[]
 *	cnt1	Aj[VJE^B
 *
 */

/*** CONTAINER ***
 *
 * [stat = 0:ʏ]
 *
 * [stat = 1:Œ]
 *	cnt1	Aj[VJE^B(_ł̂)
 *		ReiǵȀԂێ܂B
 *		莞ԌɁAONAĂB
 *
 * [stat = 2:Q[I[o[]
 *
 */

/*** BALL ***
 *
 * [stat = 0:E]
 *
 * [stat = 1:]
 *
 */

/*** STAR ***
 *
 * [stat = g܂]
 *
 */

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _MOVER {
	int type;
	int cnt;
	fixed x;
	fixed y;
	fixed vx;
	fixed vy;
} MOVER;

/* [type = 1:RYEX^[]
 *	cnt	Aj[VJE^
 *
 * [type = 2:RYE{[(p^[A)]
 *	cnt	ʉ[͂˂
 *
 * [type = 3:RYE{[(p^[B)]
 *	cnt	ʉ[͂˂
 *
 * [type = 4:{[qbg}[N] 2pXŕ`悵Ãp^[őPʕ\Ƃ邱!!
 *	cnt	Aj[VJE^
 *
 * [type = 5:10000_] 2pXŕ`悵Ãp^[őPʕ\Ƃ邱!!
 *	cnt	Aj[VJE^
 */

#define MAX_MOVER	32

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _DEBRIS {
	int c;
	int x;
	fixed y;
	fixed vy;
} DEBRIS;

#define MAX_DEBRIS	256

/****************************************************************************
 *	
 ****************************************************************************/

#define FIELD_COLS	6		/* tB[h */
#define FIELD_ROWS	(13 + 1)	/* tB[hs(O܂) */

typedef struct _GAME {
	int seed;		/* V[h */

	int score;		/* XRA */
	int level;		/* x */
	int cosmo;		/* RYŐ */
	int lines;		/* ReiŃC */
	int star;		/* X^[[^[ ({[ɂRYŐ) */

	int level_cnt;		/* ubN (xAbvɃZbg) */
	int combo;		/* AJE^ */
	int star_cancel;	/* X^[LZ(+AAorBB)JE^ */

	CELL next[3];		/* mdws (0:,1:E,2:BVÔ͍ݎgp) */
	CELL block[3];		/* ubN (0:,1:E,2:BVÔ͍ݎgp) */

	int block_cnt;		/* ubN ({[ɃZbg) */
	int block_rot;		/* ubN] (0:]/1:90x/2:180x/3:270x/4:VO) */
	int block_col;		/* ubNʒu (Z̈ʒu) */
	int block_row;
	int block_stat;		/* 0:o`҂ / 1: / 2:ڒn`ڒ҂ */
	int block_delay;	/* o`fBC or ڒn`ڒfBC */
	fixed block_pos;	/* ubNʒu(s)̒[ (̂ݎgpB1.00.0) */

	int ball_col;		/* {[ʒu */
	int ball_row;
	int ball_pos;		/* {[ʒu[ (CELL_W0) */
	int ball_dir;		/* {[ړ (0:E/1:/2:̂E/3:̂) */
	int ball_rev;		/* E]1A0Zbg */

	int star_row;		/* X^[ڒns */
	int star_ofs;		/* X^[ʍsItZbg */
	int star_pos;		/* X^[ʍsItZbg̒[[sNZ] */

	CELL field[FIELD_ROWS][FIELD_COLS];	/* tB[h */

	DEBRIS debris[MAX_DEBRIS];	/* j */
	MOVER mover[MAX_MOVER];		/* RYŃAj[V */
} GAME;

/****************************************************************************
 *	
 ****************************************************************************/

#define COSMO_TIME_TO_SLEEP	RND16_RANGE(game.seed, SEC(15), SEC(30))	/* Jn҂ */
#define COSMO_TIME_TO_WAKE	RND16_RANGE(game.seed, SEC(15), SEC(30))	/* N҂ */

#define BLOCK_PRE_FALL_DELAY	SEC(0.5)
#define BLOCK_POST_LAND_DELAY	SEC(0.5)

#define STAR_FULL	100	/* X^[[^[̃I[o[t[l */

#define BALL_SPEED	3	/* {[ړx */
#define STAR_SPEED	3	/* X^[ʍ~x */

/* xɂĕω */
#define BALL_INTERVAL	ball_interval(game.level)
#define BLOCK_SPEED	block_speed(game.level)

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo_main();

void game_init();
void game_main();

void block_gen();
int block_init();
int block_action();
int block_realize();
void block_disp();
void next_disp();
void info_disp();
int move_test(int block_col, int block_row, int block_rot);

void field_action();
void field_disp();

int fall_action();

int line_test();
int line_action();

int ball_test();
int ball_action();
void ball_disp();

int star_action();
void star_disp();

void debris_gen(int x, int y);
void debris_action();
void debris_disp();

void mover_gen(int col, int row, int type);
void mover_action();
void mover_disp(int pass);

void border_clr();
void border_set(int col, int row, int dir);

int ball_interval(int level);
fixed block_speed(int level);

int gameover_action(int step);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
